@echo off
setlocal enableDelayedExpansion
del /Q /F "%~dp0\loc.txt"
del /Q /F "%~dp0\loc2.txt"
del /Q /F "%~dp0\klucz.txt"
del /Q /F "%~dp0\klucz2.txt" 
cls
IF %~x1==.nsp (
%~dp0\hactool.exe -x -k "%~dp0keys.txt" --intype=pfs0 --pfs0dir="%~dp0\ExtractedNSP" %1
set NSP=1
cls
)
IF %~x1==.xci (
mkdir "%~dp0\ExtractedXCI"
%~dp0\hactool.exe -k "%~dp0keys.txt" --intype=xci --securedir="%~dp0\ExtractedXCI" %1
set XCI=1
cls
)
IF DEFINED XCI (
echo If your patch was inside XCI, press "1" and ENTER
echo If you don't have patch, just only press ENTER
echo .
echo .
echo .
set /p patch2="Put here your *.nsp patch file and press ENTER: "
cls
)
IF NOT %~x1==.xci (
		IF NOT %~x1==.nsp (
			echo Wrong file. Put correct *.nsp file or *.xci file
			pause
			exit
	)
)
IF DEFINED NSP (
where /r "%~dp0\ExtractedNSP" *.tik > "%~dp0\loc.txt"
set /p lokal=< "%~dp0\loc.txt"
)
IF DEFINED NSP set local=!lokal!
IF DEFINED NSP %~dp0\tf.exe %local% > "%~dp0\klucz.txt"
IF DEFINED NSP set /p titlekey=< "%~dp0\klucz.txt"
IF DEFINED NSP set tk=!titlekey!
IF DEFINED NSP (
cls
echo ---If you don't have patch file, just only press ENTER---
set /p patch="Put here your *.nsp patch file and press ENTER: "
cls
)
IF DEFINED patch (
%~dp0\hactool.exe -x -k "%~dp0keys.txt" --intype=pfs0 --pfs0dir="%~dp0\ExtractedNSPatch" %patch%
cls
echo "Put here correct NCA file (probably the biggest one) from ExtractedNSPatch folder in"
echo %~dp0
set /p patchnca="and press ENTER: "
cls
)
IF DEFINED patch (
where /r "%~dp0\ExtractedNSPatch" *.tik > "%~dp0\loc2.txt"
set /p lokal2=< "%~dp0\loc2.txt"
set local2=!lokal2!
)
IF DEFINED patch %~dp0\tf.exe %local2% > "%~dp0\klucz2.txt"
IF DEFINED patch (
set /p titlekey2=< "%~dp0\klucz2.txt"
set tk2=!titlekey2!
)
IF DEFINED patch (
echo "Put here correct NCA file (probably the biggest one) from ExtractedNSP folder in"
ECHO %~dp0
set /p bs="and press ENTER: "
cls
)
IF DEFINED patch (
mkdir "%~dp0\DecryptedNCA"
%~dp0\hactool.exe -x -k "%~dp0keys.txt" --titlekey=%tk% --plaintext="%~dp0\DecryptedNCA\Decrypted.nca" %bs%
mkdir "%~dp0\patched_%~n1"
%~dp0\hactool.exe -x -k "%~dp0keys.txt" --titlekey=%tk2% --romfsdir="%~dp0\patched_%~n1\romfs" --exefsdir="%~dp0\patched_%~n1\exefs" --basenca="%~dp0\DecryptedNCA\Decrypted.nca" %patchnca%
del /Q /F "%~dp0\loc.txt"
del /Q /F "%~dp0\loc2.txt"
del /Q /F "%~dp0\klucz.txt"
del /Q /F "%~dp0\klucz2.txt"
echo .
rmdir /s /Q "%~dp0\DecryptedNCA"
echo .
echo Finished cleaning. Game files should have been extracted to
echo %~dp0\patched_%~n1
echo .
echo Press ENTER to delete all temporary files
pause
rmdir /s /Q "%~dp0\ExtractedNSPatch"
rmdir /s /Q "%~dp0\ExtractedNSP"
echo Done
pause
EXIT
)
IF DEFINED NSP (
echo "Put here correct NCA file (probably the biggest one) from ExtractedNSP folder in"
ECHO %~dp0
set /p bs="and press ENTER: "
)
IF DEFINED NSP (
mkdir "%~dp0\%~n1"
%~dp0\hactool.exe -x -k "%~dp0keys.txt" --titlekey=%tk% --romfsdir="%~dp0\%~n1\romfs" --exefsdir="%~dp0\%~n1\exefs" %bs%
del /Q /F "%~dp0\loc.txt"
echo .
del /Q /F "%~dp0\klucz.txt"
echo .
echo Finished cleaning. Game files should have been extracted to
echo %~dp0\%~n1
echo .
echo Press ENTER to delete all temporary files
pause
rmdir /s /Q "%~dp0\ExtractedNSP"
echo Done
pause
EXIT
)
IF NOT DEFINED patch2 (
echo "Put here correct NCA file (probably the biggest one) from ExtractedXCI in folder"
echo %~dp0
set /p bs="and press ENTER "
)
IF NOT DEFINED patch2 (
mkdir "%~dp0\%~n1"
%~dp0\hactool.exe -x -k keys.txt --romfsdir="%~dp0\%~n1\romfs" --exefsdir="%~dp0\%~n1\exefs" %bs%
echo .
echo .
echo Game files should have been extracted to
echo %~dp0\%~n1
echo .
echo Press ENTER to delete all temporary files
pause
rmdir /s /Q "%~dp0\ExtractedXCI"
echo Done
pause
exit
)
IF NOT %patch2% EQU 1 (
mkdir "%~dp0\ExtractedNSPatch"
%~dp0\hactool.exe -x -k "%~dp0keys.txt" --intype=pfs0 --pfs0dir="%~dp0\ExtractedNSPatch" %patch2%
cls
echo "Put here correct NCA file (probably the biggest one) from ExtractedNSPatch folder in"
echo %~dp0
set /p patchnca="and press ENTER: "
cls
)
IF NOT %patch2% EQU 1 (
where /r "%~dp0\ExtractedNSPatch" *.tik > "%~dp0\loc2.txt"
set /p lokal2=< "%~dp0\loc2.txt"
set local2=!lokal2!
)
IF NOT %patch2% EQU 1 %~dp0\tf.exe %local2% > "%~dp0\klucz2.txt"
IF NOT %patch2% EQU 1 (
set /p titlekey2=< "%~dp0\klucz2.txt"
set tk2=!titlekey2!
)
IF NOT %patch2% EQU 1 (
echo "Put here correct NCA file (probably the biggest one) from ExtractedXCI folder in"
ECHO %~dp0
set /p bs="and press ENTER: "
cls
)
IF NOT %patch2% EQU 1 (
mkdir "%~dp0\patched_%~n1"
%~dp0\hactool.exe -x -k "%~dp0keys.txt" --titlekey=%tk2% --romfsdir="%~dp0\patched_%~n1\romfs" --exefsdir="%~dp0\patched_%~n1\exefs" --basenca="%bs%" %patchnca%
del /Q /F "%~dp0\loc2.txt"
del /Q /F "%~dp0\klucz2.txt"
echo .
echo .
echo .
echo Finished cleaning. Game files should have been extracted to
echo %~dp0\patched_%~n1
echo .
echo .
echo .
echo Press ENTER to delete all temporary files
pause
rmdir /s /Q "%~dp0\ExtractedNSPatch"
rmdir /s /Q "%~dp0\ExtractedXCI"
echo Done
pause
EXIT
)
IF %patch2%==1 (
echo "Put here correct NCA patch file (probably the second biggest file) from ExtractedXCI in folder"
echo %~dp0
set /p update="and press ENTER: "
cls
)
IF %patch2%==1 (
echo "Put here correct NCA game file (probably the biggest one) from ExtractedXCI in folder"
echo %~dp0
set /p bs="and press ENTER: "
cls
)
IF %patch2%==1 (
mkdir "%~dp0\patched_%~n1"
%~dp0\hactool.exe -x -k "%~dp0keys.txt" --romfsdir="%~dp0\patched_%~n1\romfs" --exefsdir="%~dp0\patched_%~n1\exefs" --basenca="%bs%" %update%
echo .
echo .
echo Game files should have been extracted to
echo %~dp0\patched_%~n1
echo .
echo Press ENTER to delete all temporary files
pause
rmdir /s /Q "%~dp0\ExtractedXCI"
echo Done
pause
exit
)